import apwidgets.*; //you must download and install the apwidgets library

//the following are all pieces we need to pull in from the android sdk
import android.media.SoundPool; //this is the audio player for short quick audio files
import android.content.res.AssetManager; //the asset manager helps us find specific files and can be used in the style of an array if needed
import android.media.AudioManager; //the audio manager controlls all the audio connected to it, enabeling overall volume and such

SoundPool soundPool;
AssetManager assetManager;

APWidgetContainer widgetContainer; //a contianer for our buttons
APButton button1, button2, button3, button4, button5; //our buttons, one for each sample

int sound1, sound2, sound3, sound4, sound5; //variables to hold the sound files

void setup() {
  widgetContainer = new APWidgetContainer(this); //create new container for widgets
  button1 = new APButton(10, 40, "Sample #1"); //create new button from x- and y-pos. and label. size determined by text content
  button2 = new APButton(10, 120, "Sample #2");
  button3 = new APButton(10, 200, "Sample #3");
  button4 = new APButton(10, 280, "Sample #4");
  button5 = new APButton(10, 360, "Sample #5");

  widgetContainer.addWidget(button1); //place button in container
  widgetContainer.addWidget(button2); 
  widgetContainer.addWidget(button3);
  widgetContainer.addWidget(button4);
  widgetContainer.addWidget(button5);
  
  soundPool = new SoundPool(20, AudioManager.STREAM_MUSIC, 0); //(max #of streams, stream type, source quality) - see the android reference for details
  assetManager = this.getAssets();
  try { //loading these files can throw an exception and therefore you HAVE to have a way to handle those events
  sound1 = soundPool.load(assetManager.openFd("samp1.wav"), 0); //load the files
  sound2 = soundPool.load(assetManager.openFd("samp2.wav"), 0);
  sound3 = soundPool.load(assetManager.openFd("samp3.wav"), 0);
  sound4 = soundPool.load(assetManager.openFd("samp4.wav"), 0);
  sound5 = soundPool.load(assetManager.openFd("samp5.wav"), 0);
  } catch (IOException e) {
   e.printStackTrace(); //you can leave this empty...or use some other way to notify the user/developer something went wrong
  }
}

void draw() {
  
}

//onClickWidget is called when a widget is clicked/touched
void onClickWidget(APWidget widget){
  
  if(widget == button1){ //if it was button1 that was clicked
    soundPool.play(sound1, 1, 1, 0, 0, 1); //play sound1
  }else if(widget == button2){ //or if it was button2
    soundPool.play(sound2, 1, 1, 0, 0, 1); //play sound2
  }else if(widget == button3){ //or if it was button2
    soundPool.play(sound3, 1, 1, 0, 0, 1);
  }else if(widget == button4){ //or if it was button2
    soundPool.play(sound4, 1, 1, 0, 0, 1);
  }else if(widget == button5){ //or if it was button2
    soundPool.play(sound5, 1, 1, 0, 0, 1);
  }
  
}

public void onDestroy() {

  super.onDestroy(); //call onDestroy on super class
  if(soundPool!=null) { //must be checked because or else crash when return from landscape mode
    soundPool.release(); //release the player
  }
}
